"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _slimLodash = _interopRequireDefault(require("../utils/slimLodash"));

var _CityList = _interopRequireDefault(require("./CityList"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;

var CityPicker =
/*#__PURE__*/
function (_Component) {
  _inherits(CityPicker, _Component);

  function CityPicker(props) {
    var _this;

    _classCallCheck(this, CityPicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CityPicker).call(this, props));

    _this.open = function () {
      _this.setState({
        visible: true
      });
    };

    _this.close = function () {
      _this.setState({
        visible: false
      });
    };

    _this["switch"] = function (val) {
      _this.setState(function (_ref) {
        var visible = _ref.visible;
        if (visible !== val) return {
          visible: !!val
        };
      });
    };

    _this.state = {
      visible: false
    };
    return _this;
  }
  /* 打开popup */


  _createClass(CityPicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var popWidth = this.props.popWidth;
      var visible = this.state.visible;

      var popupProps = _slimLodash["default"].pick(this.props, ['bankPlaces', 'expensePlaces', 'placesHashMap', 'bankPlacesHashMap', 'afterChange', 'value']);

      return _react["default"].createElement("div", null, _react["default"].createElement(_rcTrigger["default"], {
        action: ['click'],
        popupVisible: visible,
        destroyPopupOnHide: true,
        onPopupVisibleChange: function onPopupVisibleChange(val) {
          _this2["switch"](val);
        },
        popupAlign: {
          points: ['tl', 'bl'],
          offset: [0, -58]
        },
        popupClassName: "".concat(prefix, "-city-picker"),
        popupStyle: {
          width: popWidth
        },
        popup: _react["default"].createElement(_CityList["default"], _extends({}, popupProps, {
          showDropDown: true,
          hideDropDown: this.close
        }))
      }, this.props.children));
    }
  }]);

  return CityPicker;
}(_react.Component);

CityPicker.propTypes = {
  /** popout出来的宽度  */
  popWidth: _propTypes["default"].number
};
CityPicker.defaultProps = {
  popWidth: 500
};
var _default = CityPicker;
exports["default"] = _default;