"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

var _lodash = _interopRequireDefault(require("lodash"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;
var DEPARTMENT_PICKER = _constants["default"].DEPARTMENT_PICKER;

var DepartmentList =
/*#__PURE__*/
function (_Component) {
  _inherits(DepartmentList, _Component);

  function DepartmentList(props) {
    var _this;

    _classCallCheck(this, DepartmentList);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DepartmentList).call(this, props));

    _this.localeProcess = function (ns, key) {
      _mkTranslate["default"].getNameSpace(ns).then(function (t) {
        _this.setState(_defineProperty({}, key, t));
      });
    };

    _this.preventCheckAllCondition = function () {
      var maxSelectLength = _this.props.maxSelectLength;
      var _this$state = _this.state,
          sourceList = _this$state.sourceList,
          selectList = _this$state.selectList;
      sourceList = _lodash["default"].filter(sourceList, {
        type: DEPARTMENT_PICKER.STAFF
      });

      var common = _lodash["default"].intersectionWith(sourceList, selectList, _utils["default"].bizEquals);

      return sourceList.length > common.length + (maxSelectLength - selectList.length) && maxSelectLength > 0;
    };

    _this.toggleAll = function () {
      var _this$props = _this.props,
          scope = _this$props.scope,
          includeChildDept = _this$props.includeChildDept;
      var _this$state2 = _this.state,
          sourceList = _this$state2.sourceList,
          allSelected = _this$state2.allSelected;

      var _sourceList = _lodash["default"].map(sourceList, function (item) {
        return _objectSpread({}, item, {
          includeChildDept: includeChildDept
        });
      }); // console.log('allSelected', allSelected)


      if (scope === DEPARTMENT_PICKER.SCOPE_STAFF) {
        _sourceList = _lodash["default"].filter(_sourceList, {
          type: DEPARTMENT_PICKER.STAFF
        });
      }

      if (_this.preventCheckAllCondition()) {
        return;
      }

      _this.setState({
        selectList: _sourceList,
        allSelected: !allSelected
      });

      _this.output(_sourceList, false);
    };

    _this.toggleItem = function (e, item) {
      var _this$props2 = _this.props,
          scope = _this$props2.scope,
          maxSelectLength = _this$props2.maxSelectLength;
      var _this$state3 = _this.state,
          selectList = _this$state3.selectList,
          t = _this$state3.t;

      if (scope === DEPARTMENT_PICKER.SCOPE_STAFF && item.type === DEPARTMENT_PICKER.DEPARTMENT) {
        e.stopPropagation();
        return;
      }

      if (scope === DEPARTMENT_PICKER.SCOPE_STAFF && item.type === DEPARTMENT_PICKER.DEPARTMENT) {
        _this.drillDown(item);

        return;
      }
      /** 单选 */


      if (!maxSelectLength || maxSelectLength === 1) {
        selectList = [item];
      } else {
        var idx = _lodash["default"].findIndex(selectList, {
          code: item.code
        });

        if (idx !== -1) {
          selectList.splice(idx, 1);
        } else {
          if (selectList.length < maxSelectLength || maxSelectLength <= 0) {
            selectList.push(item);
          } else {
            _message2["default"].warning(t('departmentList.warningText', {
              n: maxSelectLength
            }));
          }
        }
      }

      _this.setState({
        selectList: selectList
      });

      _this.output(selectList, true);

      setTimeout(_this.checkAllFlag);
    };

    _this.checkAllFlag = function () {
      var scope = _this.props.scope;
      var _this$state4 = _this.state,
          sourceList = _this$state4.sourceList,
          selectList = _this$state4.selectList;
      var targetList;

      if (scope === DEPARTMENT_PICKER.SCOPE_STAFF) {
        targetList = _lodash["default"].filter(sourceList, {
          type: DEPARTMENT_PICKER.STAFF
        });
      } else {
        targetList = sourceList;
      }

      var allSelected = targetList.length && !_lodash["default"].find(targetList, function (dep) {
        return !_lodash["default"].find(selectList, {
          code: dep.code
        });
      });

      _this.setState({
        allSelected: allSelected
      });
    };

    _this.drillDown = function (item) {
      var onDrillDown = _this.props.onDrillDown;

      if (typeof onDrillDown === 'function') {
        onDrillDown(item);
      }
    };

    _this.output = function (selectList, itemSelected) {
      var onOutput = _this.props.onOutput;
      var _this$state5 = _this.state,
          sourceList = _this$state5.sourceList,
          allSelected = _this$state5.allSelected;
      var result = {
        added: selectList,
        removed: _lodash["default"].differenceWith(sourceList, selectList, function (o1, o2) {
          return o1.code === o2.code;
        }),
        allSelected: allSelected,
        itemSelected: itemSelected
      };

      if (typeof onOutput === 'function') {
        onOutput(result);
      }
    };

    _this.state = {
      sourceList: props.sourceList || [],
      selectList: props.selectList || [],
      allSelected: false,
      t: _mkTranslate["default"].noop(),
      gt: _mkTranslate["default"].noop()
    };

    _this.localeProcess('DepartmentSelectionModal', 't');

    _this.localeProcess('MkGlobal', 'gt');

    return _this;
  }

  _createClass(DepartmentList, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var sourceList = nextProps.sourceList,
          selectList = nextProps.selectList;

      if (sourceList) {
        this.setState({
          sourceList: sourceList
        });
      }

      if (selectList) {
        this.setState({
          selectList: selectList
        });
      }

      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkAllFlag();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          canDrillDown = _this$props3.canDrillDown,
          loading = _this$props3.loading,
          scope = _this$props3.scope,
          maxSelectLength = _this$props3.maxSelectLength,
          renderAddition = _this$props3.renderAddition,
          includeChildDept = _this$props3.includeChildDept;
      var _this$state6 = this.state,
          sourceList = _this$state6.sourceList,
          selectList = _this$state6.selectList,
          allSelected = _this$state6.allSelected,
          className = _this$state6.className,
          gt = _this$state6.gt,
          t = _this$state6.t;
      var containerClass = (0, _classnames["default"])("".concat(prefix, "-department-picker-list"), className);
      var selectClass = (0, _classnames["default"])('select-all-btn', {
        'disabled': this.preventCheckAllCondition()
      });
      var allSelectedClass = (0, _classnames["default"])({
        'selected': allSelected
      });
      return _react["default"].createElement("div", {
        className: containerClass
      }, Number(maxSelectLength) === 1 ? null : _react["default"].createElement("div", {
        className: 'opt-bar'
      }, _react["default"].createElement("div", {
        className: selectClass,
        onClick: this.toggleAll
      }, _react["default"].createElement("span", {
        className: allSelectedClass + " fm fm-check"
      }), _react["default"].createElement("span", null, allSelected ? gt('MkGlobal:selectInvert') : gt('MkGlobal:selectAll')))), _react["default"].createElement(_list["default"], {
        size: "small",
        loading: loading,
        dataSource: sourceList,
        renderItem: function renderItem(item) {
          var selected = _lodash["default"].findIndex(selectList, {
            code: item.code
          }) !== -1;
          var fullName;

          if (item.fullName) {
            var _name = item.fullName.indexOf(',') > -1 ? item.fullName.split(',')[0] : item.fullName;

            var _symbol = _name.indexOf('/') > -1 ? '/' : '\\';

            var _a = _name.split(_symbol);

            fullName = _a.slice(-(_a.length - 1)).join(_symbol);
          }

          var itemClass = (0, _classnames["default"])({
            selected: selected,
            notick: scope === DEPARTMENT_PICKER.SCOPE_STAFF && item.type === DEPARTMENT_PICKER.DEPARTMENT
          });
          return _react["default"].createElement(_list["default"].Item, {
            className: itemClass,
            key: item.code,
            onClick: function onClick(e) {
              var _item = _objectSpread({}, item, {
                includeChildDept: includeChildDept
              });

              _this2.toggleItem(e, _item);
            }
          }, _react["default"].createElement("div", {
            className: "item-content ".concat(item.isRoot ? 'item-root' : '')
          }, Number(maxSelectLength) === 1 ? selected ? _react["default"].createElement("span", {
            className: "fm fm-circle-check-o"
          }) : _react["default"].createElement("span", {
            className: "fm fm-radio"
          }) : _react["default"].createElement("span", {
            className: "fm fm-check"
          }), item.type === DEPARTMENT_PICKER.STAFF ? _react["default"].createElement("span", {
            className: "fm fm-employee"
          }) : _react["default"].createElement("span", {
            className: "fm fm-cube"
          }), _react["default"].createElement("div", null, _react["default"].createElement("span", {
            className: "name"
          }, item.name, " ", renderAddition && renderAddition(item)), fullName ? _react["default"].createElement("div", {
            className: "fullname"
          }, fullName) : null)), item.type === DEPARTMENT_PICKER.DEPARTMENT && item.hasChildren && (item.hasDepartments && scope === DEPARTMENT_PICKER.DEPARTMENT || scope !== DEPARTMENT_PICKER.DEPARTMENT) && canDrillDown ? _react["default"].createElement("span", {
            className: 'fm fm-organization',
            onClick: function onClick(e) {
              e.stopPropagation();

              _this2.drillDown(item);
            }
          }, t('departmentList.subordinate')) : null);
        }
      }));
    }
  }]);

  return DepartmentList;
}(_react.Component);

DepartmentList.defaultProps = {
  canDrillDown: true
};
var _default = DepartmentList;
exports["default"] = _default;