"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slimLodash = _interopRequireDefault(require("../utils/slimLodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* 共享字段映射 */
function genShareFieldFormula(field, shareFields) {
  var result = [];

  if (field && shareFields) {
    _slimLodash["default"].forEach(shareFields, function (item) {
      result.push({
        targetField: item.identifier,
        referField: field.identifier,
        formula: item.identifier,
        privateParser: true,
        registerVariables: [item.identifier],
        updatePool: function updatePool(fieldValue, formData) {
          var result = {};
          var customObj = {};
          /* 当前共享字段都是custom级别的字段 */

          if (fieldValue && _slimLodash["default"].isArray(fieldValue) && fieldValue.length > 0) {
            customObj = fieldValue[0].customObject;
          } else if (fieldValue && _slimLodash["default"].isObject(fieldValue)) {
            customObj = fieldValue.customObject;
          }

          if (!fieldValue || fieldValue && _slimLodash["default"].isEmpty(fieldValue)) {
            customObj = _defineProperty({}, item.identifier, undefined);
          }

          if (_slimLodash["default"].has(customObj, item.identifier)) {
            result[item.identifier] = customObj[item.identifier];
          }

          return result;
        }
      });
    });
  }

  return result;
}

var _default = genShareFieldFormula;
exports["default"] = _default;