"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/tag/style/css");

var _tag = _interopRequireDefault(require("maycur-antd/lib/tag"));

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _FilterDropDown = require("../../FilterDropDown");

var _reactI18next = require("react-i18next");

var _i18next = _interopRequireDefault(require("i18next"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var DepartmentModal = function DepartmentModal(props) {
  var width = props.width,
      restProps = _objectWithoutProperties(props, ["width"]);

  return _react["default"].createElement(_modal["default"], _extends({}, restProps, {
    footer: null,
    visible: true,
    wrapClassName: 'department-modal-wrapper'
  }), _react["default"].createElement(_FilterDropDown.DepartmentPickerFilter, props));
};

var DepartmentPicker =
/*#__PURE__*/
function (_Component) {
  _inherits(DepartmentPicker, _Component);

  function DepartmentPicker(props) {
    var _this;

    _classCallCheck(this, DepartmentPicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DepartmentPicker).call(this, props));

    _this.localeProcess = function () {
      _mkTranslate["default"].getNameSpace('MkTable').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.openModal = function () {
      var _this$props = _this.props,
          ModalManager = _this$props.ModalManager,
          selectedKeys = _this$props.selectedKeys,
          setSelectedKeys = _this$props.setSelectedKeys,
          confirm = _this$props.confirm,
          restProps = _objectWithoutProperties(_this$props, ["ModalManager", "selectedKeys", "setSelectedKeys", "confirm"]);

      ModalManager.open({
        component: DepartmentModal,
        componentProps: _objectSpread({}, restProps, {
          selectedKeys: selectedKeys && selectedKeys.departments,
          confirm: confirm
        })
      }).then(function (data) {
        if (data) {
          var _data = _lodash["default"].map(data, function (item) {
            return _lodash["default"].pick(item, ['code', 'name']);
          });

          _this.setState({
            value: _data
          });

          setSelectedKeys(_data);
          confirm();
        }
      })["catch"]();
    };

    _this.state = {
      value: props.selectedKeys && props.selectedKeys.departments,
      t: _mkTranslate["default"].noop()
    };

    _this.localeProcess();

    return _this;
  }

  _createClass(DepartmentPicker, [{
    key: "render",
    value: function render() {
      var _this$state = this.state,
          value = _this$state.value,
          t = _this$state.t;
      var maxShowLength = this.props.maxShowLength;
      return _react["default"].createElement("div", {
        className: 'department-picker-wrapper',
        onClick: this.openModal
      }, value && value.length ? _lodash["default"].take(value, maxShowLength).map(function (item) {
        return _react["default"].createElement(_tag["default"], {
          className: 'department-name',
          key: item.code
        }, _react["default"].createElement("span", {
          className: 'fm fm-cube'
        }), item.name);
      }) : _react["default"].createElement("span", {
        className: 'department-empty'
      }, t('empty')), value && value.length > maxShowLength ? _react["default"].createElement("span", {
        className: 'department-stats'
      }, _react["default"].createElement(_reactI18next.Trans, {
        i18n: _i18next["default"],
        i18nKey: "departmentPicker.status",
        ns: "MkTable",
        values: {
          n: value.length
        },
        components: [_react["default"].createElement("span", null), _react["default"].createElement("span", {
          className: "strong"
        })],
        children: "\u5171 <span className={'strong'}>{{value.length}}</span> \u9879"
      })) : null, _react["default"].createElement("span", {
        className: 'fm fm-more2'
      }));
    }
  }]);

  return DepartmentPicker;
}(_react.Component);

DepartmentPicker.defaultProps = {
  maxShowLength: 5
};
var _default = DepartmentPicker;
exports["default"] = _default;