"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _RangeCalendar = _interopRequireDefault(require("./RangeCalendar"));

var _SelectComp = _interopRequireDefault(require("./SelectComp"));

var _AmountRange = _interopRequireDefault(require("./AmountRange"));

var _DepartmentPicker = _interopRequireDefault(require("./DepartmentPicker"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// import utils from '../../../utils/utils';
// const { prefixCls: prefix } = utils;
var typeComponentMap = {
  'dateRange': _RangeCalendar["default"],
  'checkbox': _SelectComp["default"],
  'department': _DepartmentPicker["default"],
  'numberRange': _AmountRange["default"]
};

var IncludeContent =
/*#__PURE__*/
function (_Component) {
  _inherits(IncludeContent, _Component);

  function IncludeContent(props) {
    var _this;

    _classCallCheck(this, IncludeContent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(IncludeContent).call(this, props));

    _this.open = function () {
      _this.setState({
        visible: true
      });
    };

    _this.close = function () {
      _this.setState({
        visible: false
      });
    };

    _this["switch"] = function (val) {
      _this.setState(function (_ref) {
        var visible = _ref.visible;
        if (visible !== val) return {
          visible: !!val
        };
      });
    };

    _this.setSelectedKeys = function (selectedKeys) {
      _this.value = selectedKeys;

      _this.setState({
        value: selectedKeys
      });
    };

    _this.confirm = function () {
      var _this$props = _this.props,
          column = _this$props.field,
          onChange = _this$props.onChange;

      var customFilterItemDto = _defineProperty({}, column.key, _this.value);

      onChange(_objectSpread({}, customFilterItemDto));

      _this.close();
    };

    _this.clearFilters = function () {
      console.log('clearFilters');
    };

    _this.columnModify = function (col, changed) {
      console.log('columnModify', changed);
    };

    _this.state = {
      value: props.value,
      visible: false
    };
    _this.value = props.value;
    return _this;
  }
  /* 打开popup */


  _createClass(IncludeContent, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          field = _this$props2.field,
          ModalManager = _this$props2.ModalManager,
          columns = _this$props2.columns;
      var value = this.state.value;
      var Cop = typeComponentMap[field.filterOption.type];
      return _react["default"].createElement(Cop, _extends({}, field, {
        setSelectedKeys: this.setSelectedKeys,
        selectedKeys: value,
        confirm: this.confirm,
        clearFilters: this.clearFilters,
        columnModify: this.columnModify,
        columns: columns,
        showNumberRangeOkBtn: false,
        ModalManager: ModalManager
      }));
    }
  }]);

  return IncludeContent;
}(_react.Component);

var _default = IncludeContent;
exports["default"] = _default;