"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/date-picker/style/css");

var _datePicker = _interopRequireDefault(require("maycur-antd/lib/date-picker"));

var _react = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _i18next = require("i18next");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var RangePicker = _datePicker["default"].RangePicker;
var prefix = _utils["default"].prefixCls,
    rangeOptions = [{
  value: 'recentOne',
  label: (0, _i18next.t)('MkTable:rangeCalendar.recentOne')
}, {
  value: 'recentThree',
  label: (0, _i18next.t)('MkTable:rangeCalendar.recentThree')
}];

var RangeCalendarFilter =
/*#__PURE__*/
function (_Component) {
  _inherits(RangeCalendarFilter, _Component);

  function RangeCalendarFilter(props) {
    var _this;

    _classCallCheck(this, RangeCalendarFilter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RangeCalendarFilter).call(this, props));

    _this.onChange = function (nextValue) {
      var _this$props = _this.props,
          confirm = _this$props.confirm,
          setSelectedKeys = _this$props.setSelectedKeys;

      if (nextValue) {
        if (nextValue.length === 2) {
          nextValue[0] = (0, _moment["default"])(nextValue[0]).startOf('day');
          nextValue[1] = (0, _moment["default"])(nextValue[1]).endOf('day');
        }

        _this.setState({
          selectedValue: nextValue
        }, function () {
          setSelectedKeys(nextValue);

          if (nextValue.length > 1) {
            confirm();
          }
        });
      }
    };

    _this.renderExtraFooter = function () {
      var isNeedSideBar = _this.props.isNeedSideBar;
      return isNeedSideBar && _react["default"].createElement("div", {
        className: "tabs"
      }, rangeOptions.map(function (item, index) {
        return _react["default"].createElement("span", {
          className: 'tab',
          onClick: _this.onChoose.bind(_assertThisInitialized(_this), item.value),
          key: index
        }, item.label);
      }));
    };

    _this.onChoose = function (value) {
      var now = new Date();
      var _this$props2 = _this.props,
          confirm = _this$props2.confirm,
          setSelectedKeys = _this$props2.setSelectedKeys;

      _this.setState({
        range: value
      }, function () {
        switch (value) {
          case 'recentThree':
            _this.setState({
              selectedValue: [(0, _moment["default"])(now).subtract(3, 'months'), (0, _moment["default"])()]
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          case 'recentOne':
            _this.setState({
              selectedValue: [(0, _moment["default"])(now).subtract(1, 'months'), (0, _moment["default"])()]
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          default:
            break;
        }
      });
    };

    _this.state = {
      selectedValue: [],
      range: ''
    };
    return _this;
  }

  _createClass(RangeCalendarFilter, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var selectedKeys = this.props.selectedKeys;

      if (selectedKeys && selectedKeys.startDate && selectedKeys.endDate) {
        this.setState({
          selectedValue: [(0, _moment["default"])(selectedKeys.startDate), (0, _moment["default"])(selectedKeys.endDate)]
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement(RangePicker, {
        dropdownClassName: "".concat(prefix, "-range-calendar"),
        defaultValue: this.state.selectedValue,
        value: this.state.selectedValue,
        onChange: this.onChange,
        renderExtraFooter: this.renderExtraFooter
      });
    }
  }]);

  return RangeCalendarFilter;
}(_react.Component);

RangeCalendarFilter.defaultProps = {
  isNeedSideBar: true
};
var _default = RangeCalendarFilter;
exports["default"] = _default;