"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

require("maycur-antd/lib/form/style/css");

var _form = _interopRequireDefault(require("maycur-antd/lib/form"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _IncludeContent = _interopRequireDefault(require("../IncludeContent"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;

var FilterSettingPanel =
/*#__PURE__*/
function (_Component) {
  _inherits(FilterSettingPanel, _Component);

  function FilterSettingPanel(props) {
    var _this;

    _classCallCheck(this, FilterSettingPanel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FilterSettingPanel).call(this, props));

    _this.localeProcess = function () {
      _mkTranslate["default"].getNameSpace('MkTable').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.validateIncludeContent = function (rule, value, callback, field) {
      var t = _this.state.t;

      if (!value) {
        callback(t('filterSettingPanel.content'));
        return;
      }

      if (field.filterOption.type === 'numberRange') {
        var minAmount, maxAmount;

        if (value[field.key]) {
          var _value$field$key$spli = value[field.key].split('~');

          var _value$field$key$spli2 = _slicedToArray(_value$field$key$spli, 2);

          minAmount = _value$field$key$spli2[0];
          maxAmount = _value$field$key$spli2[1];
        } else {
          minAmount = value.minAmount;
          maxAmount = value.maxAmount;
        }

        if (Number(minAmount) >= Number(maxAmount)) {
          callback(t('filterSettingPanel.range'));
          return;
        } else {
          callback();
        }
      }

      callback();
    };

    _this.state = {
      t: _mkTranslate["default"].noop()
    };

    _this.localeProcess();

    return _this;
  }

  _createClass(FilterSettingPanel, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          getFieldDecorator = _this$props.form.getFieldDecorator,
          data = _this$props.data,
          addFilterCondition = _this$props.addFilterCondition,
          deleteFilterCondition = _this$props.deleteFilterCondition,
          ModalManager = _this$props.ModalManager,
          columns = _this$props.columns,
          _this$props$filterCol = _this$props.filterColumns,
          filterColumns = _this$props$filterCol === void 0 ? [] : _this$props$filterCol;
      var t = this.state.t;
      return _react["default"].createElement(_form["default"], {
        className: "".concat(prefix, "-filter-setting-form-wrapper")
      }, _react["default"].createElement("div", {
        className: "filter-name-field"
      }, _react["default"].createElement(_form["default"].Item, {
        label: t('filterSettingPanel.label')
      }, getFieldDecorator('filterName', {
        rules: [{
          required: true,
          message: t('filterSettingPanel.rule')
        }, {
          max: 10,
          message: t('filterSettingPanel.message')
        }]
      })(_react["default"].createElement(_input["default"], null))), _react["default"].createElement("div", {
        className: "line"
      })), data.customFilterItemList.map(function (item, index) {
        var field = _lodash["default"].find(columns, {
          key: data.customFilterItemList[index].key
        });

        return _react["default"].createElement("div", {
          key: item.code
        }, _react["default"].createElement("div", {
          className: "filter-item-title"
        }, _react["default"].createElement("span", null, t('filterSettingPanel.title', {
          n: index + 1
        })), _react["default"].createElement("span", {
          className: "fm fm-trash",
          onClick: function onClick() {
            return deleteFilterCondition(index);
          }
        })), _react["default"].createElement("div", {
          className: "filter-item-form"
        }, _react["default"].createElement(_form["default"].Item, {
          label: t('filterSettingPanel.itemLabel')
        }, getFieldDecorator("customFilterItemList[".concat(index, "].key"), {
          rules: [{
            required: true,
            message: t('filterSettingPanel.itemMessage')
          }]
        })(_react["default"].createElement(_select["default"], null, columns.map(function (column) {
          var disabled = !_lodash["default"].find(filterColumns, function (filterColumn) {
            return column.key === filterColumn.key;
          });
          return _react["default"].createElement(_select["default"].Option, {
            key: column.key,
            value: column.key,
            disabled: disabled
          }, column.title);
        })))), data.customFilterItemList[index].key && _react["default"].createElement(_form["default"].Item, {
          label: t('filterSettingPanel.customLabel')
        }, getFieldDecorator("customFilterItemList[".concat(index, "].customFilterItemDto"), {
          rules: [{
            required: true,
            message: t('filterSettingPanel.customMessage')
          }, {
            validator: function validator(rule, value, callback) {
              return _this2.validateIncludeContent(rule, value, callback, field);
            }
          }]
        })(_react["default"].createElement(_IncludeContent["default"], {
          columns: columns,
          ModalManager: ModalManager,
          field: field
        })))));
      }), _react["default"].createElement(_button["default"], {
        className: "add-condition-btn",
        onClick: addFilterCondition
      }, _react["default"].createElement("span", {
        className: "fm fm-plus"
      }), t('filterSettingPanel.addBtn')));
    }
  }]);

  return FilterSettingPanel;
}(_react.Component);

var _default = _form["default"].create({
  mapPropsToFields: function mapPropsToFields(props) {
    var data = props.data,
        fields = props.fields;

    var customFilterItemList = _lodash["default"].map(data.customFilterItemList, function (item, index) {
      var field = {};

      _lodash["default"].each(['key', 'customFilterItemDto'], function (key) {
        fields.customFilterItemList = fields.customFilterItemList || [];
        fields.customFilterItemList[index] = fields.customFilterItemList[index] || {};
        field[key] = _form["default"].createFormField(_objectSpread({}, fields.customFilterItemList[index][key], {
          value: data.customFilterItemList[index][key]
        }));
      });

      return field;
    });

    return {
      filterName: _form["default"].createFormField(_objectSpread({}, fields.filterName, {
        value: data.filterName
      })),
      customFilterItemList: customFilterItemList
    };
  },
  onFieldsChange: function onFieldsChange(props, changedFields) {
    props.onChange(changedFields);
  }
})(FilterSettingPanel);

exports["default"] = _default;