"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;

var PopContent =
/*#__PURE__*/
function (_Component) {
  _inherits(PopContent, _Component);

  function PopContent(props) {
    var _this;

    _classCallCheck(this, PopContent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PopContent).call(this, props));

    _this.onChange = function (checkedValues) {
      _this.setState({
        checkedValues: checkedValues
      });
    };

    _this.getValue = function () {
      var _this$state = _this.state,
          options = _this$state.options,
          checkedValues = _this$state.checkedValues;
      ;
      var outValues = [];

      _lodash["default"].forEach(options, function (item) {
        if (checkedValues.includes(item.code)) {
          outValues.push(item);
        }
      });

      return outValues;
    };

    _this.setDefaultValue = function () {
      var defaultValue = _this.props.defaultValue;
      var convertValue = [];

      _lodash["default"].forEach(defaultValue, function (option) {
        convertValue.push(option.code);
      });

      return convertValue;
    };

    _this.state = {
      options: props.options || [],
      checkedValues: _this.setDefaultValue()
    };
    return _this;
  }

  _createClass(PopContent, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var visible = this.props.visible;

      if (prevProps.visible !== visible && visible) {
        this.setState({
          checkedValues: this.setDefaultValue()
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state2 = this.state,
          options = _this$state2.options,
          checkedValues = _this$state2.checkedValues;
      return _react["default"].createElement("div", {
        className: "".concat(prefix, "-popcontent")
      }, _react["default"].createElement(_checkbox["default"].Group, {
        value: checkedValues,
        onChange: this.onChange
      }, options.map(function (optionItem) {
        return _react["default"].createElement("div", {
          key: optionItem.code,
          className: "".concat(prefix, "-option-child")
        }, _react["default"].createElement(_checkbox["default"], {
          value: optionItem.code
        }, optionItem.name));
      })));
    }
  }]);

  return PopContent;
}(_react.Component);

var PopSelect =
/*#__PURE__*/
function (_Component2) {
  _inherits(PopSelect, _Component2);

  function PopSelect(props) {
    var _this2;

    _classCallCheck(this, PopSelect);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(PopSelect).call(this, props));

    _this2.onVisibleChange = function (visible) {
      var close = _this2.props.close;

      _this2.setState({
        visible: visible
      });

      if (!visible && _this2.contentRef) {
        if (typeof close === 'function') {
          close(_this2.contentRef.getValue());
        }
      }
    };

    _this2.onValueChange = function () {};

    _this2.state = {
      visible: false
    };
    return _this2;
  }

  _createClass(PopSelect, [{
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          defaultValue = _this$props.defaultValue,
          children = _this$props.children,
          options = _this$props.options;
      var visible = this.state.visible;

      var popContent = _react["default"].createElement(PopContent, {
        visible: visible,
        ref: function ref(_ref) {
          _this3.contentRef = _ref;
        },
        options: options,
        defaultValue: defaultValue
      });

      return _react["default"].createElement(_popover["default"], {
        content: popContent,
        trigger: "click",
        placement: "bottomLeft",
        overlayClassName: "".concat(prefix, "-select-popover"),
        autoAdjustOverflow: true,
        onVisibleChange: this.onVisibleChange
      }, children);
    }
  }]);

  return PopSelect;
}(_react.Component);

var _default = PopSelect;
exports["default"] = _default;