"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Option = _select["default"].Option;

var BankInput =
/*#__PURE__*/
function (_Component) {
  _inherits(BankInput, _Component);

  function BankInput(props) {
    var _this;

    _classCallCheck(this, BankInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BankInput).call(this, props));

    _this.filterOption = function (inputValue, option) {
      var title = option.props.title;
      return (title || '').indexOf(inputValue) !== -1;
    };

    _this.state = {
      banks: props.banks || []
    };
    return _this;
  }

  _createClass(BankInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props = this.props,
          banks = _this$props.banks,
          fetchBanks = _this$props.fetchBanks;

      if (_lodash["default"].isEmpty(banks) && typeof fetchBanks === 'function') {
        fetchBanks().then(function (banks) {
          _this2.setState({
            banks: banks
          });
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          value = _this$props2.value,
          defaultValues = _this$props2.defaultValues;
      var banks = this.state.banks;

      if (!_lodash["default"].find(banks, {
        code: value
      })) {
        value = undefined;
      } // 未知类型的开户银行不可选择，只可通过接口生成


      return _react["default"].createElement(_select["default"], _extends({}, this.props, {
        value: defaultValues ? defaultValues : value,
        disabled: disabled,
        filterOption: this.filterOption,
        showSearch: true
      }), (banks || []).map(function (bank) {
        return _react["default"].createElement(Option, {
          key: bank.code,
          value: bank.code,
          title: bank.name,
          data: bank,
          disabled: bank.code === 'unknown'
        }, bank.name);
      }));
    }
  }]);

  return BankInput;
}(_react.Component);

var _default = BankInput;
exports["default"] = _default;