"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = findIndex;

var _find = _interopRequireDefault(require("./find"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
* Ponyfill for Array.prototype.findIndex
* @param {Array} arr
* @param {Function} checkFn
* @return index of the item in the array
*/
function findIndex(arr, checkFn) {
  if (Array.prototype.findIndex) {
    return arr.findIndex(checkFn);
  } // fallback


  return arr.indexOf((0, _find["default"])(arr, checkFn));
}