"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ManagePicker = _interopRequireDefault(require("../ManagePicker"));

var _constants = _interopRequireDefault(require("../utils/constants"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var MANAGE_PICKER = _constants["default"].MANAGE_PICKER;

var TradingPartnerPicker =
/*#__PURE__*/
function (_Component) {
  _inherits(TradingPartnerPicker, _Component);

  function TradingPartnerPicker(props) {
    var _this;

    _classCallCheck(this, TradingPartnerPicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TradingPartnerPicker).call(this, props));

    _this.fetchSourceList = function (categoryCode) {
      var pageParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var getTradingPartnerTree = _this.props.getTradingPartnerTree;

      var params = _objectSpread({
        parentCode: categoryCode
      }, pageParams);

      return getTradingPartnerTree(params, {
        pageId: MANAGE_PICKER.SOURCE_LIST
      }).then(function (resp) {
        if (resp.code === 'ACK') {
          var data = resp.data && resp.data.data || [];

          _lodash["default"].forEach(data, function (item) {
            if (!item.partnerProperty) {
              item.type = MANAGE_PICKER.CATEGORY;
              item.hasMore = item.hasChildren;
              item.icon = "fm fm-folder-o";
            } else {
              item.type = MANAGE_PICKER.ITEM;
              item.icon = item.partnerProperty === 'CORP' ? 'fm fm-legal-entity' : 'fm fm-store';
            }
          });

          return data;
        }
      });
    };

    _this.fetchSearchList = function (keywords) {
      var pageParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return _this.props.searchPartner(_objectSpread({
        keywords: keywords
      }, pageParams), {
        pageId: MANAGE_PICKER.SEARCH_LIST
      }).then(function (res) {
        var data = res.data && res.data.data || [];

        _lodash["default"].forEach(data, function (item) {
          item.type = MANAGE_PICKER.ITEM;
          item.icon = item.partnerProperty === 'CORP' ? 'fm fm-legal-entity' : 'fm fm-store';
        });

        return data;
      });
    };

    _this.state = {};
    return _this;
  }

  _createClass(TradingPartnerPicker, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement(_ManagePicker["default"], _extends({
        title: "\u5F80\u6765\u5355\u4F4D",
        fetchSourceList: this.fetchSourceList,
        fetchSearchList: this.fetchSearchList
      }, this.props));
    }
  }]);

  return TradingPartnerPicker;
}(_react.Component);

TradingPartnerPicker.defaultProps = {
  getTradingPartnerTree: function getTradingPartnerTree() {},
  searchPartner: function searchPartner() {},
  paging: true,
  pageSize: 50
};
var _default = TradingPartnerPicker;
exports["default"] = _default;