"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/tree/style/css");

var _tree = _interopRequireDefault(require("maycur-antd/lib/tree"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;
var TreeNode = _tree["default"].TreeNode;

var SelectableTree =
/*#__PURE__*/
function (_Component) {
  _inherits(SelectableTree, _Component);

  function SelectableTree(props) {
    var _this;

    _classCallCheck(this, SelectableTree);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SelectableTree).call(this, props));

    _this.onLoadData = function (treeNode) {
      var fetchChildren = _this.props.fetchChildren;
      var dataRef = treeNode.props.dataRef;
      return new Promise(function (resolve, reject) {
        if (typeof fetchChildren === 'function') {
          fetchChildren(dataRef).then(function (children) {
            _this.buildMap(children);

            if (_lodash["default"].isArray(dataRef.children)) {
              dataRef.children = [].concat(_toConsumableArray(dataRef.children), _toConsumableArray(children));
            } else {
              dataRef.children = children;
            }

            _this.setState({
              treeData: _toConsumableArray(_this.state.treeData)
            });

            resolve();
          })["catch"](function (error) {
            return reject();
          });
        } else {
          reject();
        }
      });
    };

    _this.buildMap = function (data) {
      var onBuildMap = _this.props.onBuildMap;

      if (typeof onBuildMap === 'function') {
        onBuildMap(data);
      }
    };

    _this.onCheck = function (checkedKeys, e) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          checkStrictly = _this$props.checkStrictly;

      if (typeof onChange === 'function') {
        if (checkStrictly) {
          onChange(checkedKeys.checked);
        } else {
          onChange(checkedKeys);
        }
      }
    };

    _this.renderTreeNodes = function (nodes) {
      return _lodash["default"].isArray(nodes) && nodes.length > 0 ? nodes.map(function (item) {
        var nodeClass = (0, _classnames["default"])('node', {
          'disabled': item.enabled === false,
          'leaf': item._type === 'LEAF',
          'category': item._type === 'CATEGORY'
        });
        return _react["default"].createElement(TreeNode, {
          blockNode: true,
          selectable: false,
          className: nodeClass,
          key: item.code,
          value: item.code,
          disableCheckbox: item.disableCheckbox,
          isLeaf: item._type === 'LEAF',
          dataRef: item,
          title: item._type === 'LEAF' ? _react["default"].createElement("span", {
            className: 'node-label'
          }, _react["default"].createElement("span", {
            className: "fm fm-paper"
          }), item.name) : _react["default"].createElement("span", {
            className: 'node-label'
          }, _react["default"].createElement("span", {
            className: "fm fm-folder-o"
          }), item.name)
        }, _lodash["default"].isArray(item.children) && item.children.length > 0 ? _this.renderTreeNodes(item.children) : null);
      }) : null;
    };

    _this.state = {
      treeData: props.dataSource ? props.dataSource : null
    };
    return _this;
  }

  _createClass(SelectableTree, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (!_lodash["default"].isEqual(nextProps.dataSource, this.props.dataSource)) {
        this.setState({
          treeData: nextProps.dataSource
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          checkedKeys = _this$props2.checkedKeys,
          checkStrictly = _this$props2.checkStrictly;
      var treeData = this.state.treeData;
      return _react["default"].createElement("div", {
        className: "".concat(prefix, "-selectable-tree-view")
      }, treeData ? _react["default"].createElement(_tree["default"], {
        checkable: true,
        blockNode: true,
        autoExpandParent: true,
        checkStrictly: checkStrictly,
        checkedKeys: checkedKeys,
        loadData: this.onLoadData,
        onCheck: this.onCheck
      }, this.renderTreeNodes(treeData)) : 'loading tree');
    }
  }]);

  return SelectableTree;
}(_react.Component);

SelectableTree.defaultProps = {
  checkStrictly: true
};
var _default = SelectableTree;
exports["default"] = _default;