"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _i18next = _interopRequireDefault(require("i18next"));

var _reactI18next = require("react-i18next");

var _i18nextXhrBackend = _interopRequireDefault(require("i18next-xhr-backend"));

var _i18nextBrowserLanguagedetector = _interopRequireDefault(require("i18next-browser-languagedetector"));

var _i18nextIntervalpluralPostprocessor = _interopRequireDefault(require("i18next-intervalplural-postprocessor"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2019-09-27 16:48:15
 * @LastEditors: RongWei
 * @LastEditTime: 2019-11-29 17:53:07
 */
var detection = {
  order: ['localStorage', 'navigator'],
  lookupLocalStorage: 'lang',
  caches: ['localStorage']
};
var backend = {
  loadPath: function loadPath(lngs, namespaces) {
    var lng = lngs[0].startsWith('zh') ? 'zh' : 'en';
    return "locales/".concat(lng, "/").concat(namespaces[0], ".json");
  }
};

_i18next["default"].use(_i18nextXhrBackend["default"]).use(_i18nextBrowserLanguagedetector["default"]).use(_i18nextIntervalpluralPostprocessor["default"]).use(_reactI18next.initReactI18next).init({
  ns: ['MkGlobal', 'PaymentAccountModal', 'MkbsCityList', 'Empty'],
  defaultNS: 'MkGlobal',
  // 默认的命名空间
  backend: backend,
  detection: detection,
  lng: 'en',
  fallbackLng: 'en',
  interpolation: {
    escapeValue: false
  },
  debug: false,
  saveMissing: false,
  partialBundledLanguages: true,
  parseMissingKeyHandler: function parseMissingKeyHandler() {
    return '...';
  },
  react: {
    useSuspense: false
  }
});

var _default = _i18next["default"];
exports["default"] = _default;