"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;
var colors = ['c1', 'c2', 'c3', 'c4', 'c5', 'c6', 'c7', 'c8', 'c9'];

function hashCode(str) {
  str = str || '';

  if (Array.prototype.reduce) {
    return str.split('').reduce(function (a, b) {
      a = (a << 5) - a + b.charCodeAt(0);
      return a & a;
    }, 0);
  }

  var hash = 0;
  if (str.length === 0) return hash;

  for (var i = 0; i < str.length; i++) {
    var character = str.charCodeAt(i);
    hash = (hash << 5) - hash + character;
    hash = hash & hash; // Convert to 32bit integer
  }

  return hash;
}

var Avatar =
/*#__PURE__*/
function (_Component) {
  _inherits(Avatar, _Component);

  function Avatar(props) {
    var _this;

    _classCallCheck(this, Avatar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Avatar).call(this, props));

    _this.localeProcess = function () {
      _mkTranslate["default"].getNameSpace('Avatar').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.state = {
      abbrName: '',
      color: '',
      t: _mkTranslate["default"].noop()
    };
    _this.getAbbrName = _this.getAbbrName.bind(_assertThisInitialized(_this));
    _this.updateState = _this.updateState.bind(_assertThisInitialized(_this));
    _this.onClickAvatar = _this.onClickAvatar.bind(_assertThisInitialized(_this));

    _this.localeProcess();

    return _this;
  }

  _createClass(Avatar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var user = this.props.user;
      this.updateState(user);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var user = nextProps.user;
      this.updateState(user);
    }
  }, {
    key: "updateState",
    value: function updateState(user) {
      if (user) {
        var abbrName = this.getAbbrName(user.userName);
        var idx = Math.abs(hashCode(user.userName)) % colors.length;
        this.setState({
          abbrName: abbrName,
          color: colors[idx]
        });
      }
    }
  }, {
    key: "onClickAvatar",
    value: function onClickAvatar(e) {
      e.stopPropagation();
      var onClick = this.props.onClick;

      if (typeof onClick === 'function') {
        onClick();
      }
    }
  }, {
    key: "getAbbrName",
    value: function getAbbrName(name) {
      if (!name) return '';
      var chineseReg = new RegExp("[\u4E00-\uFA29\uE7C7-\uE7F3]+", 'g');
      var wordReg = new RegExp('[A-Za-z]{1,4}');
      var result = '';
      var m = (name || '').match(chineseReg);

      if (m && m.length !== 0) {
        result = m[0];

        if (result && result.length > 2) {
          result = result.substring(result.length - 2, result.length);
        }
      }

      if (!result) {
        m = (name || '').match(wordReg);

        if (m && m.length !== 0) {
          result = m[0];
        }
      }

      if (!result) {
        result = name.substr(0, 1);
      }

      return result;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          customStyle = _this$props.customStyle,
          avatarUrl = _this$props.avatarUrl;
      var t = this.state.t;
      return _react["default"].createElement(_react["default"].Fragment, null, avatarUrl ? _react["default"].createElement("img", {
        className: "".concat(prefix, "-avatar-img"),
        src: avatarUrl,
        alt: t('abbrName'),
        style: _objectSpread({}, customStyle)
      }) : _react["default"].createElement("span", {
        onClick: this.onClickAvatar,
        className: "".concat(prefix, "-avatar ").concat(this.state.color || 'c0'),
        style: _objectSpread({}, customStyle)
      }, _react["default"].createElement("span", null, this.state.abbrName || t('abbrName'))));
    }
  }]);

  return Avatar;
}(_react.Component);

Avatar.propTypes = {
  /** 个人用户信息  */
  user: _propTypes["default"].object,

  /** 自定义组件style  */
  customStyle: _propTypes["default"].object
};
var _default = Avatar;
exports["default"] = _default;