"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Search = _input["default"].Search;
var basicCls = "".concat(_utils["default"].prefixCls, "-currency-selector");

function CurrencyItem(props) {
  var currency = props.currency,
      handleClick = props.handleClick;
  var itemCls = "".concat(basicCls, "-item");
  return _react["default"].createElement("div", {
    onClick: function onClick() {
      handleClick(currency);
    },
    className: itemCls
  }, _react["default"].createElement("span", {
    className: "".concat(itemCls, "_code")
  }, currency.code), _react["default"].createElement("span", {
    className: "".concat(itemCls, "_divider")
  }, "-"), _react["default"].createElement("span", {
    className: "".concat(itemCls, "_name")
  }, currency.name));
}

var CurrencySelector =
/*#__PURE__*/
function (_Component) {
  _inherits(CurrencySelector, _Component);

  function CurrencySelector(props) {
    var _this;

    _classCallCheck(this, CurrencySelector);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CurrencySelector).call(this, props));

    _this["switch"] = function (val) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          visibleChange = _this$props.visibleChange;

      if (!disabled) {
        _this.setState({
          visible: val,
          searchKey: ''
        });

        if (typeof visibleChange === 'function') visibleChange(val);
      }
    };

    _this.close = function () {
      _this.setState({
        visible: false,
        searchKey: ''
      });
    };

    _this.search = function (key) {
      _this.setState({
        searchKey: key || ''
      });
    };

    _this.choose = function (currency) {
      var onChange = _this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(currency);
      }

      _this.close();
    };

    _this.state = {
      visible: false,
      searchKey: ''
    };
    return _this;
  }

  _createClass(CurrencySelector, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          currencyList = _this$props2.data,
          latestCurrencys = _this$props2.latestCurrencys,
          popWidth = _this$props2.popWidth,
          _this$props2$offset = _this$props2.offset,
          offset = _this$props2$offset === void 0 ? [] : _this$props2$offset,
          loading = _this$props2.loading;
      var _this$state = this.state,
          searchKey = _this$state.searchKey,
          visible = _this$state.visible;

      var MainList = _react["default"].createElement("div", {
        className: "".concat(basicCls, "-wrapper")
      }, loading ? null : _react["default"].createElement("div", {
        className: "".concat(basicCls, "-search")
      }, _react["default"].createElement(Search, {
        type: "gray",
        placeholder: "\u8BF7\u8F93\u8D27\u5E01\u7B80\u79F0\u3001\u540D\u79F0\u641C\u7D22",
        onChange: function onChange(e) {
          _this2.search(e.target.value);
        }
      })), _react["default"].createElement("div", {
        className: "".concat(basicCls, "-body")
      }, searchKey ? null : _react["default"].createElement("div", {
        className: "".concat(basicCls, "-latest")
      }, _react["default"].createElement("div", {
        className: "".concat(basicCls, "-label")
      }, "\u6700\u8FD1\u4F7F\u7528"), currencyList.map(function (currency) {
        var itemProps = {
          currency: currency,
          handleClick: _this2.choose,
          key: currency.code
        };
        var itemVisible = false;

        if (latestCurrencys && latestCurrencys.length > 0 && latestCurrencys.includes(currency.code)) {
          itemVisible = true;
        }

        return itemVisible ? _react["default"].createElement(CurrencyItem, itemProps) : null;
      })), _react["default"].createElement("div", {
        className: "".concat(basicCls, "-list")
      }, _react["default"].createElement("div", {
        className: "".concat(basicCls, "-label")
      }, "\u8D27\u5E01\u7C7B\u578B"), currencyList.map(function (currency) {
        var itemProps = {
          currency: currency,
          handleClick: _this2.choose,
          key: currency.code
        };
        var itemVisible = true;
        var isSearch = !!searchKey;

        if (isSearch) {
          var reg = new RegExp(searchKey, 'i');

          if (reg.test(currency.code) || reg.test(currency.name)) {
            itemVisible = true;
          } else {
            itemVisible = false;
          }
        }

        return itemVisible ? _react["default"].createElement(CurrencyItem, itemProps) : null;
      }))), loading ? _react["default"].createElement("div", {
        className: "".concat(basicCls, "-loading")
      }) : null);

      return _react["default"].createElement(_rcTrigger["default"], {
        action: ['click'],
        popupVisible: visible,
        destroyPopupOnHide: true,
        onPopupVisibleChange: function onPopupVisibleChange(val) {
          _this2["switch"](val);
        },
        popupAlign: {
          points: ['tl', 'bl'],
          offset: offset
        },
        popupClassName: basicCls,
        popupStyle: {
          width: popWidth
        },
        popup: MainList
      }, this.props.children);
    }
  }]);

  return CurrencySelector;
}(_react.Component);

CurrencySelector.defaultProps = {
  data: [],
  latestCurrencys: [],
  //保存的是货币的code信息
  popWidth: 300,
  disabled: false,
  loading: false //加载状态

};
CurrencySelector.propTypes = {
  /** 所有可选货币数据  */
  data: _propTypes["default"].array,

  /** 最近被选过的货币代号  */
  latestCurrencys: _propTypes["default"].array,

  /** 选择组件的宽度  */
  popWidth: _propTypes["default"].number,
  visibleChange: _propTypes["default"].func,
  loading: _propTypes["default"].bool
};
var _default = CurrencySelector;
exports["default"] = _default;