"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

require("maycur-antd/lib/switch/style/css");

var _switch = _interopRequireDefault(require("maycur-antd/lib/switch"));

var _react = _interopRequireWildcard(require("react"));

var _DepartmentTransfer = _interopRequireDefault(require("../DepartmentTransfer"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;
var DEPARTMENT_PICKER = _constants["default"].DEPARTMENT_PICKER;

var DepartmentSelection =
/*#__PURE__*/
function (_Component) {
  _inherits(DepartmentSelection, _Component);

  function DepartmentSelection(props) {
    var _this;

    _classCallCheck(this, DepartmentSelection);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DepartmentSelection).call(this, props));

    _this.localeProcess = function () {
      _mkTranslate["default"].getNameSpace('DepartmentSelectionModal').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.onChange = function (selectList) {
      _this.setState({
        selectList: selectList
      });
    };

    _this.onOk = function () {
      var selectList = _this.state.selectList;
      var _this$props = _this.props,
          isModalManager = _this$props.isModalManager,
          promise = _this$props.promise,
          modalCallBack = _this$props.modalProps.modalCallBack;

      if (isModalManager && promise) {
        promise.resolve(selectList);
      } else if (typeof modalCallBack === 'function') {
        modalCallBack(selectList);
      }
    };

    _this.onCancel = function () {
      var _this$props2 = _this.props,
          isModalManager = _this$props2.isModalManager,
          modalProps = _this$props2.modalProps,
          promise = _this$props2.promise;
      var onCancel = modalProps.onCancel;

      if (isModalManager && promise) {
        promise.reject();
      } else if (typeof onCancel === 'function') {
        onCancel();
      }
    };

    _this.onSwitchChange = function (checked) {
      _this.setState({
        switchChecked: checked
      });
    };

    var pickerProps = props.pickerProps;
    _this.state = {
      selectList: pickerProps && pickerProps.selectList ? _lodash["default"].cloneDeep(pickerProps.selectList) : [],
      switchChecked: pickerProps && pickerProps.switchChecked,
      t: _mkTranslate["default"].noop()
    };

    _this.localeProcess();

    return _this;
  }

  _createClass(DepartmentSelection, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var modalProps = this.props.modalProps;
      var selectList = this.state.selectList;
      var includeChildDept;

      if (_lodash["default"].isEmpty(selectList) && modalProps.showIncludeChildConfig) {
        includeChildDept = true;
      } else {
        includeChildDept = selectList[0] && selectList[0].includeChildDept;
      }

      this.setState({
        includeChildDept: includeChildDept
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          modalProps = _this$props3.modalProps,
          pickerProps = _this$props3.pickerProps;
      var _this$state = this.state,
          switchChecked = _this$state.switchChecked,
          selectList = _this$state.selectList,
          includeChildDept = _this$state.includeChildDept,
          t = _this$state.t;
      var title;

      switch (pickerProps.scope) {
        case DEPARTMENT_PICKER.SCOPE_DEPARTMENT:
          title = _react["default"].createElement("div", {
            className: "title"
          }, _react["default"].createElement("div", null, t('departmentSelection.selectDepartment')), pickerProps.isSwitch && _react["default"].createElement("div", {
            className: "switch"
          }, _react["default"].createElement(_switch["default"], {
            checked: switchChecked,
            disabled: pickerProps.switchDisabled,
            onChange: this.onSwitchChange
          }), _react["default"].createElement("span", null, t('departmentSelection.departmentSpan')), _react["default"].createElement(_popover["default"], {
            placement: "right",
            content: _react["default"].createElement("div", {
              className: "".concat(prefix, "-popover")
            }, t('departmentSelection.departmentPopover'))
          }, _react["default"].createElement("span", {
            className: "fm fm-question"
          }))));
          break;

        case DEPARTMENT_PICKER.SCOPE_STAFF:
          title = t('departmentSelection.selectStaff');
          break;

        default:
          title = t('departmentSelection.selectAll');
          break;
      }

      title = pickerProps.isShowUserGroup ? "".concat(title, "\u3001").concat(t('departmentSelection.userGroup')) : title;

      var footer = _react["default"].createElement("div", {
        className: "footer"
      }, pickerProps.scope !== 'SCOPE_STAFF' && modalProps.showIncludeChildConfig && _react["default"].createElement("div", {
        className: "include"
      }, _react["default"].createElement(_checkbox["default"], {
        checked: includeChildDept,
        onChange: function onChange(e) {
          _this2.setState({
            includeChildDept: e.target.checked,
            selectList: _lodash["default"].map(selectList, function (item) {
              return _objectSpread({}, item, {
                includeChildDept: e.target.checked
              });
            })
          });
        }
      }, t('departmentSelection.departmentSpan'), _react["default"].createElement(_popover["default"], {
        placement: "right",
        content: _react["default"].createElement("div", {
          className: "".concat(prefix, "-popover")
        }, t('departmentSelection.departmentPopover'))
      }, _react["default"].createElement("span", {
        className: "fm fm-question"
      })))), _react["default"].createElement("div", {
        className: "btns-wrap"
      }, _react["default"].createElement("div", {
        className: "help"
      }, t('MkGlobal:helpText'), _react["default"].createElement("a", {
        href: "https://www.yuque.com/ruanruan-eydfh/yb01tu/adugpa",
        rel: "noopener noreferrer",
        target: "_blank"
      }, t('MkGlobal:help'))), _react["default"].createElement("div", {
        className: "btn"
      }, _react["default"].createElement(_button["default"], {
        key: "back",
        type: "info",
        size: "large",
        onClick: this.onCancel
      }, t('MkGlobal:cancel')), _react["default"].createElement(_button["default"], {
        key: "submit",
        type: "primary",
        size: "large",
        onClick: this.onOk
      }, t('MkGlobal:ok')))));

      return _react["default"].createElement(_modal["default"], _extends({}, modalProps, {
        title: title,
        footer: footer,
        onCancel: this.onCancel,
        destroyOnClose: true,
        maskClosable: false,
        keyboard: false,
        centered: true,
        className: "".concat(prefix, "-department-picker-select")
      }), _react["default"].createElement(_DepartmentTransfer["default"], _extends({}, pickerProps, {
        fetchDepartmentChildren: pickerProps.fetch,
        fetchUserGroup: pickerProps.fetchUserGroup,
        searchDepartmentChildren: pickerProps.search,
        includeChildDept: includeChildDept,
        selectList: selectList,
        onChange: this.onChange
      })));
    }
  }]);

  return DepartmentSelection;
}(_react.Component);

DepartmentSelection.defaultProps = {
  isActionModal: false,
  modalProps: {},
  pickerProps: {}
};
var _default = DepartmentSelection;
exports["default"] = _default;