"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;
var MANAGE_PICKER = _constants["default"].MANAGE_PICKER;

var ManageList =
/*#__PURE__*/
function (_Component) {
  _inherits(ManageList, _Component);

  function ManageList(props) {
    var _this;

    _classCallCheck(this, ManageList);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ManageList).call(this, props));
    _this.state = {
      sourceList: props.sourceList || [],
      selectList: props.selectList || [],
      allSelected: false
    };
    _this.toggleAll = _this.toggleAll.bind(_assertThisInitialized(_this));
    _this.toggleItem = _this.toggleItem.bind(_assertThisInitialized(_this));
    _this.drillDown = _this.drillDown.bind(_assertThisInitialized(_this));
    _this.output = _this.output.bind(_assertThisInitialized(_this));
    _this.checkAllFlag = _this.checkAllFlag.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ManageList, [{
    key: "preventCheckAllCondition",
    value: function preventCheckAllCondition() {
      var maxSelectLength = this.props.maxSelectLength;
      var _this$state = this.state,
          sourceList = _this$state.sourceList,
          selectList = _this$state.selectList;
      sourceList = _lodash["default"].filter(sourceList, {
        type: MANAGE_PICKER.ITEM
      });

      var common = _lodash["default"].intersectionWith(sourceList, selectList, _utils["default"].bizEquals);

      return sourceList.length > common.length + (maxSelectLength - selectList.length) && maxSelectLength > 0 || !sourceList.length;
    }
  }, {
    key: "toggleAll",
    value: function toggleAll() {
      var _this$state2 = this.state,
          sourceList = _this$state2.sourceList,
          allSelected = _this$state2.allSelected;
      sourceList = _lodash["default"].filter(sourceList, {
        type: MANAGE_PICKER.ITEM
      });

      if (this.preventCheckAllCondition()) {
        return;
      }

      this.setState({
        selectList: sourceList,
        allSelected: !allSelected
      });
      this.output(sourceList, false);
    }
  }, {
    key: "toggleItem",
    value: function toggleItem(e, item) {
      var maxSelectLength = this.props.maxSelectLength;
      var selectList = this.state.selectList;

      if (item.type === MANAGE_PICKER.CATEGORY) {
        e.stopPropagation();
        return;
      }
      /** 单选 */


      if (!maxSelectLength || maxSelectLength === 1) {
        selectList = [item];
      } else {
        var idx = _lodash["default"].findIndex(selectList, {
          code: item.code
        });

        if (idx !== -1) {
          selectList.splice(idx, 1);
        } else {
          if (selectList.length < maxSelectLength || maxSelectLength <= 0) {
            selectList.push(item);
          } else {
            _message2["default"].warning("超出限制，最多只能选择" + maxSelectLength + "项");
          }
        }
      }

      this.setState({
        selectList: selectList
      });
      this.output(selectList, true);
      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "checkAllFlag",
    value: function checkAllFlag() {
      var _this$state3 = this.state,
          sourceList = _this$state3.sourceList,
          selectList = _this$state3.selectList;

      var targetList = _lodash["default"].filter(sourceList, {
        type: MANAGE_PICKER.ITEM
      });

      var allSelected = targetList.length && !_lodash["default"].find(targetList, function (dep) {
        return !_lodash["default"].find(selectList, {
          code: dep.code
        });
      });
      this.setState({
        allSelected: allSelected
      });
    }
  }, {
    key: "drillDown",
    value: function drillDown(item) {
      var onDrillDown = this.props.onDrillDown;

      if (typeof onDrillDown === "function") {
        onDrillDown(item);
      }
    }
  }, {
    key: "output",
    value: function output(selectList, itemSelected) {
      var allSelected = this.state.allSelected;
      var onOutput = this.props.onOutput;
      var result = {
        added: selectList,
        allSelected: allSelected,
        itemSelected: itemSelected
      };

      if (typeof onOutput === "function") {
        onOutput(result);
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var sourceList = nextProps.sourceList,
          selectList = nextProps.selectList;

      if (sourceList) {
        this.setState({
          sourceList: sourceList
        });
      }

      if (selectList) {
        this.setState({
          selectList: selectList
        });
      }

      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkAllFlag();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state4 = this.state,
          sourceList = _this$state4.sourceList,
          selectList = _this$state4.selectList,
          allSelected = _this$state4.allSelected,
          className = _this$state4.className;
      var _this$props = this.props,
          canDrillDown = _this$props.canDrillDown,
          loading = _this$props.loading,
          paging = _this$props.paging,
          loadMore = _this$props.loadMore,
          loadMoreFunc = _this$props.loadMoreFunc;
      var containerClass = (0, _classnames["default"])("".concat(prefix, "-manage-list"), className);
      var selectClass = (0, _classnames["default"])("select-all-btn", {
        disabled: this.preventCheckAllCondition()
      });
      var allSelectedClass = (0, _classnames["default"])({
        selected: allSelected
      });
      return _react["default"].createElement("div", {
        className: containerClass
      }, _react["default"].createElement("div", {
        className: "opt-bar"
      }, _react["default"].createElement("div", {
        className: selectClass,
        onClick: this.toggleAll
      }, _react["default"].createElement("span", {
        className: allSelectedClass + " fm fm-check"
      }), _react["default"].createElement("span", null, allSelected ? "反选" : "全选"))), _react["default"].createElement(_list["default"], {
        size: "small",
        loading: loading,
        loadMore: paging && loadMore && (sourceList || []).length ? _react["default"].createElement("div", {
          onClick: function onClick() {
            return loadMoreFunc();
          },
          className: 'load-more'
        }, "\u52A0\u8F7D\u66F4\u591A") : null,
        dataSource: sourceList,
        renderItem: function renderItem(item) {
          var selected = _lodash["default"].findIndex(selectList, {
            code: item.code
          }) !== -1;
          var itemClass = (0, _classnames["default"])({
            selected: selected,
            notick: item.type === MANAGE_PICKER.CATEGORY
          });
          return _react["default"].createElement(_list["default"].Item, {
            className: itemClass,
            key: item.code,
            onClick: function onClick(e) {
              _this2.toggleItem(e, item);
            }
          }, _react["default"].createElement("div", {
            className: 'item-content'
          }, _react["default"].createElement("span", {
            className: 'fm fm-check'
          }), _react["default"].createElement("span", {
            className: 'manage-picker-item-name'
          }, item.icon && _react["default"].createElement("span", {
            className: item.icon
          }), item.name)), item.type === MANAGE_PICKER.CATEGORY && !selected && item.hasMore && canDrillDown ? _react["default"].createElement("span", {
            className: 'fm fm-organization',
            onClick: function onClick(e) {
              e.stopPropagation();

              _this2.drillDown(item);
            }
          }, " \u4E0B\u7EA7") : null);
        }
      }));
    }
  }]);

  return ManageList;
}(_react.Component);

ManageList.defaultProps = {
  canDrillDown: true
};
var _default = ManageList;
exports["default"] = _default;