"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Tippy = _interopRequireDefault(require("../Tippy"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;
var Tooltip = _Tippy["default"].Tooltip;

var MkDropdown =
/*#__PURE__*/
function (_Component) {
  _inherits(MkDropdown, _Component);

  function MkDropdown(props) {
    var _this;

    _classCallCheck(this, MkDropdown);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MkDropdown).call(this, props));

    _this.onUpdate = function (dataObject) {
      // reset style
      var _this$props = _this.props,
          top = _this$props.top,
          left = _this$props.left,
          overlay = _this$props.overlay,
          onUpdate = _this$props.onUpdate,
          deviation = _this$props.deviation;
      var popper = dataObject.instance.popper;
      var placement = dataObject.placement;
      var _top = dataObject.popper.top;
      var _left = dataObject.popper.left;
      var num = deviation ? _top - top + 2 : _top - top;

      var _top_ = placement === 'bottom' ? Math.round(_top + top) : Math.round(num); // const _left_ = _left.toString().includes('.') ? 2 * _left - parseInt(_left) + left : _left + left;


      var _left_ = _left + left;

      var children = [];
      popper.style.transform = "translate3d(".concat(_left_, "px, ").concat(_top_, "px, 0px)"); // flip children

      if (placement === 'top') {
        var length = overlay.props.children.length;

        for (var i = 0; i <= length - 1; i++) {
          children[i] = overlay.props.children[length - 1 - i];
        }
      }

      _this.setState({
        overlay: _react["default"].cloneElement(overlay, _objectSpread({}, overlay.props, placement === 'top' ? {
          children: children
        } : null))
      });

      onUpdate && onUpdate(dataObject);
    };

    _this.onClick = function (e) {
      var autoHide = _this.props.autoHide;
      e.stopPropagation();

      if (_this.tippyRef && autoHide) {
        _this.tippyRef.current.hideTooltip();
      }
    };

    _this.onCreate = function (dataObject) {
      var onCreate = _this.props.onCreate;
      onCreate && onCreate(dataObject);
    };

    _this.state = {
      overlay: props.overlay
    };
    _this.tippyRef = _react["default"].createRef();
    return _this;
  }

  _createClass(MkDropdown, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      this.setState({
        overlay: nextProps.overlay
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          open = _this$props2.open,
          position = _this$props2.position,
          trigger = _this$props2.trigger,
          delay = _this$props2.delay,
          hideDelay = _this$props2.hideDelay,
          animation = _this$props2.animation,
          duration = _this$props2.duration,
          distance = _this$props2.distance,
          offset = _this$props2.offset,
          followCursor = _this$props2.followCursor,
          inertia = _this$props2.inertia,
          stickyDuration = _this$props2.stickyDuration,
          test = _this$props2.test,
          className = _this$props2.className,
          style = _this$props2.style;
      var props = {
        disabled: disabled,
        position: position,
        trigger: trigger,
        delay: delay,
        hideDelay: hideDelay,
        animation: animation,
        duration: duration,
        distance: distance,
        offset: offset,
        followCursor: followCursor,
        inertia: inertia,
        stickyDuration: stickyDuration
      };
      var overlay = this.state.overlay;

      var _className = (0, _classnames["default"])("".concat(prefix, "_dropdown"), (_classNames = {}, _defineProperty(_classNames, className, className), _defineProperty(_classNames, "".concat(prefix, "_dropdown_test"), test), _classNames));

      var html = _react["default"].createElement("div", {
        className: _className,
        style: style,
        onClick: this.onClick
      }, overlay);

      return _react["default"].createElement(Tooltip, _extends({}, props, {
        open: open || test,
        html: html,
        onUpdate: this.onUpdate,
        onCreate: this.onCreate,
        interactive: true,
        animateFill: false,
        transitionFlip: true,
        unmountHTMLWhenHide: true,
        ref: this.tippyRef
      }), this.props.children);
    }
  }]);

  return MkDropdown;
}(_react.Component);

MkDropdown.defaultProps = {
  top: 0,
  left: 0,
  position: 'bottom',
  boundariesElement: 'window',
  deviation: true,
  autoHide: false
};
var _default = MkDropdown;
exports["default"] = _default;