"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _TreeTransfer = _interopRequireDefault(require("../../../TreeTransfer/TreeTransfer"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _i18next = require("i18next");

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;

var BudgetmentFilter =
/*#__PURE__*/
function (_Component) {
  _inherits(BudgetmentFilter, _Component);

  function BudgetmentFilter(props) {
    var _this;

    _classCallCheck(this, BudgetmentFilter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BudgetmentFilter).call(this, props));

    _this.localeProcess = function () {
      _mkTranslate["default"].getNameSpace('MkTable').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.onChange = function (selectList) {
      var _this$props = _this.props,
          confirm = _this$props.confirm,
          setSelectedKeys = _this$props.setSelectedKeys,
          selectedKeys = _this$props.selectedKeys,
          columnModify = _this$props.columnModify,
          col = _objectWithoutProperties(_this$props, ["confirm", "setSelectedKeys", "selectedKeys", "columnModify"]);

      var colCopy = _lodash["default"].cloneDeep(col);

      colCopy.key = colCopy.dataIndex;
      var selectedList = selectList.map(function (item) {
        return item.name;
      });

      if (colCopy) {
        columnModify(colCopy, {
          key: 'selectedList',
          value: selectedList
        });
      }

      setSelectedKeys(selectList);
    };

    _this.onOk = function () {
      var confirm = _this.props.confirm;
      confirm();
    };

    _this.fetchBudgetment = function () {
      var dataSourceSync = _this.props.dataSourceSync;
      return new Promise(function (resolve, reject) {
        dataSourceSync().then(function (res) {
          if (res.code === 'ACK') {
            _lodash["default"].forEach(res.data, function (item) {
              item._type = item.leaf ? 'LEAF' : 'CATEGORY';
              item.disableCheckbox = !item.leaf;
            });

            resolve(res.data);
          }
        });
      });
    };

    _this.fetchBudgetmentChildren = function (node) {
      var fetchChildren = _this.props.fetchChildren;
      return new Promise(function (resolve, reject) {
        fetchChildren({
          code: node.code
        }).then(function (res) {
          if (res.code === 'ACK') {
            _lodash["default"].forEach(res.data, function (item) {
              item._type = item.leaf ? 'LEAF' : 'CATEGORY';
              item.disableCheckbox = !item.leaf;
            });

            resolve(res.data);
          }
        });
      });
    };

    _this.searchBudgetment = function (keyword) {
      var search = _this.props.search;
      return new Promise(function (resolve, reject) {
        search({
          data: keyword
        }).then(function (res) {
          if (res.code === 'ACK') {
            _lodash["default"].forEach(res.data, function (item) {
              item._type = item.leaf ? 'LEAF' : 'CATEGORY';
              item.disableCheckbox = !item.leaf;
            });

            resolve(res.data);
          } else {
            reject();
          }
        })["catch"](function (error) {
          reject();
        });
      });
    };

    _this.state = {
      t: _mkTranslate["default"].noop()
    };

    _this.localeProcess();

    return _this;
  }

  _createClass(BudgetmentFilter, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          selectedKeys = _this$props2.selectedKeys,
          clearFilters = _this$props2.clearFilters;
      var t = this.state.t;
      return _react["default"].createElement("div", {
        className: "".concat(prefix, "-budgetment-filter-dropdown")
      }, _react["default"].createElement(_TreeTransfer["default"], _extends({
        onChange: this.onChange,
        value: selectedKeys
      }, this.props, {
        dataSourceSync: this.fetchBudgetment,
        fetchChildren: this.fetchBudgetmentChildren,
        search: this.searchBudgetment,
        placeholder: t('budgetmentFilter.placeholder')
      })), _react["default"].createElement("div", {
        className: 'footer'
      }, _react["default"].createElement("div", {
        className: 'btn'
      }, _react["default"].createElement(_button["default"], {
        key: "back",
        type: "info",
        size: "large",
        onClick: function onClick() {
          return clearFilters();
        },
        style: {
          marginRight: 20
        }
      }, (0, _i18next.t)('MkGlobal:cancel')), _react["default"].createElement(_button["default"], {
        key: "submit",
        type: "primary",
        size: "large",
        onClick: this.onOk
      }, (0, _i18next.t)('MkGlobal:ok')))));
    }
  }]);

  return BudgetmentFilter;
}(_react.Component);

var _default = BudgetmentFilter;
exports["default"] = _default;