"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

require("maycur-antd/lib/spin/style/css");

var _spin = _interopRequireDefault(require("maycur-antd/lib/spin"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _i18next = require("i18next");

var _lodash = _interopRequireDefault(require("lodash"));

var _Empty = _interopRequireDefault(require("../../../Empty"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;
var Search = _input["default"].Search;

var CheckFilter =
/*#__PURE__*/
function (_Component) {
  _inherits(CheckFilter, _Component);

  function CheckFilter(props) {
    var _this;

    _classCallCheck(this, CheckFilter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CheckFilter).call(this, props));

    _this.fetchFilters = function () {
      var filtersSync = _this.props.filtersSync;

      if (typeof filtersSync === 'function') {
        _this.setState({
          loading: true
        });

        filtersSync().then(function (res) {
          _this.filtersSource = res;

          _this.setState({
            filters: res,
            loading: false
          });
        }, function () {
          _this.setState({
            loading: false
          });
        });
      }
    };

    _this.onChange = function (value) {
      var setSelectedKeys = _this.props.setSelectedKeys;

      _this.setMap(value);

      setSelectedKeys(value);
    };

    _this.setMap = function (value) {
      if (typeof _this.props.filtersSync !== 'function') return;
      _this.checkedValue = value || [];

      if (value && value.length) {
        var _assertThisInitialize = _assertThisInitialized(_this),
            nameMap = _assertThisInitialize.nameMap;

        var _assertThisInitialize2 = _assertThisInitialized(_this),
            filtersSource = _assertThisInitialize2.filtersSource;

        filtersSource.forEach(function (_ref) {
          var key = _ref.value,
              text = _ref.text;

          if (!(key in nameMap) && value.includes(key)) {
            nameMap[key] = text;
          }
        });
      }
    };

    _this.onSearch = function (value) {
      var search = _this.props.search;
      var filtered;

      if (typeof search === 'function') {
        _this.setState({
          loading: true
        });

        search(value).then(function (res) {
          _this.setState({
            filters: res,
            loading: false
          });
        }, function () {
          _this.setState({
            loading: false
          });
        });
      } else {
        if (value) {
          filtered = _lodash["default"].filter(_this.filtersSource, function (o) {
            return _lodash["default"].includes(o.text, value);
          });

          _this.setState({
            filters: filtered
          });
        } else {
          filtered = _this.filtersSource;

          _this.setState({
            filters: filtered
          });
        }
      }
    };

    _this.onChangeSearchKey = function (e) {
      _this.setState({
        searchKey: e.target.value
      });
    };

    _this.selectAll = function (e) {
      var setSelectedKeys = _this.props.setSelectedKeys;
      var filters = _this.state.filters;

      if (e.target.checked) {
        var all = _lodash["default"].map(filters, 'value');

        setSelectedKeys(all);
      } else {
        setSelectedKeys();
      }
    };

    _this.onConfirm = function () {
      var _this$props = _this.props,
          confirm = _this$props.confirm,
          filtersSync = _this$props.filtersSync;

      if (typeof filtersSync === 'function') {
        _this.setFiltersMap();
      }

      confirm();
    };

    _this.reset = function () {
      var setSelectedKeys = _this.props.setSelectedKeys;
      setSelectedKeys();

      _this.setState({
        searchKey: null
      }, function () {
        _this.onSearch(_this.state.searchKey);
      });
    };

    _this.state = {
      filters: props.filters,
      searchKey: null,
      loading: false
    };
    _this.nameMap = {};
    _this.checkedValue = [];
    _this.filtersSource = props.filters || [];
    return _this;
  }

  _createClass(CheckFilter, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.fetchFilters();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(preProps, preState) {
      if (preProps.filters.length !== this.props.filters.length || preProps.needUpdate !== this.props.needUpdate) {
        this.filtersSource = this.props.filters;
        this.setState({
          filters: this.props.filters
        });
      }

      if (preProps.filtersSync !== this.props.filtersSync) {
        this.fetchFilters();
      }
    }
  }, {
    key: "setFiltersMap",
    value: function setFiltersMap() {
      var _this$props2 = this.props,
          setFiltersMap = _this$props2.setFiltersMap,
          dataIndex = _this$props2.dataIndex,
          title = _this$props2.title,
          filterMultiple = _this$props2.filterMultiple;

      if (dataIndex && typeof setFiltersMap === 'function') {
        var checkedValue = this.checkedValue,
            nameMap = this.nameMap;
        setFiltersMap(dataIndex, {
          filters: filterMultiple ? checkedValue.map(function (value) {
            return {
              value: value,
              text: nameMap[value]
            };
          }) : [{
            value: checkedValue,
            text: nameMap[checkedValue]
          }],
          title: title,
          filterOption: {
            type: 'checkbox'
          }
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          placeholder = _this$props3.placeholder,
          selectedKeys = _this$props3.selectedKeys,
          filterMultiple = _this$props3.filterMultiple,
          _this$props3$showSear = _this$props3.showSearch,
          showSearch = _this$props3$showSear === void 0 ? true : _this$props3$showSear;
      var _this$state = this.state,
          filters = _this$state.filters,
          searchKey = _this$state.searchKey,
          loading = _this$state.loading;

      var _selectedKeys = !filterMultiple && selectedKeys instanceof Array ? selectedKeys[0] : selectedKeys;

      return _react["default"].createElement("div", {
        className: "".concat(prefix, "-check-filter")
      }, showSearch ? _react["default"].createElement("div", {
        className: 'pin-search'
      }, _react["default"].createElement(Search, {
        value: searchKey,
        onSearch: this.onSearch,
        onChange: this.onChangeSearchKey,
        placeholder: placeholder
      })) : null, loading && _react["default"].createElement(_spin["default"], null), filterMultiple ? _react["default"].createElement("div", {
        className: "".concat(prefix, "-check-filter_pin-box")
      }, _react["default"].createElement(_checkbox["default"].Group, {
        onChange: this.onChange,
        value: _selectedKeys
      }, filters && filters.length > 0 ? filters.map(function (item, index) {
        return _react["default"].createElement(_checkbox["default"], {
          value: item.value,
          className: 'pin-item',
          key: index
        }, item.text);
      }) : _react["default"].createElement(_Empty["default"], null))) : _react["default"].createElement("div", {
        className: 'pin-radio-box'
      }, _react["default"].createElement(_radio["default"].Group, {
        onChange: function onChange(e) {
          return _this2.onChange(e.target.value);
        },
        value: _selectedKeys
      }, filters && filters.length > 0 ? filters.map(function (item, index) {
        return _react["default"].createElement(_radio["default"], {
          className: 'pin-item',
          value: item.value,
          key: index
        }, item.text);
      }) : _react["default"].createElement(_Empty["default"], null))), _react["default"].createElement("div", {
        className: 'pin-footer'
      }, _react["default"].createElement("div", {
        onClick: this.reset,
        className: 'footer-item weaker-item'
      }, (0, _i18next.t)('MkGlobal:reset')), _react["default"].createElement("div", {
        onClick: this.onConfirm,
        className: 'footer-item'
      }, (0, _i18next.t)('MkGlobal:ok'))));
    }
  }]);

  return CheckFilter;
}(_react.Component);

CheckFilter.defaultProps = {
  filters: [],
  filterMultiple: false
};
var _default = CheckFilter;
exports["default"] = _default;