"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _RangeCalendar = _interopRequireDefault(require("rc-calendar/lib/RangeCalendar"));

require("rc-calendar/assets/index.css");

require("rc-time-picker/assets/index.css");

var _zh_CN = _interopRequireDefault(require("rc-calendar/lib/locale/zh_CN"));

var _lodash = _interopRequireDefault(require("lodash"));

var _moment = _interopRequireDefault(require("moment"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;

var DateFilter =
/*#__PURE__*/
function (_Component) {
  _inherits(DateFilter, _Component);

  function DateFilter(props) {
    var _this;

    _classCallCheck(this, DateFilter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DateFilter).call(this, props));

    _this.localeProcess = function () {
      _mkTranslate["default"].getNameSpace('MkTable').then(function (t) {
        _this.setState({
          t: t,
          rangeOptions: [{
            value: 'all',
            label: t('dateFilter.all')
          }, {
            value: 'recentOne',
            label: t('dateFilter.recentOne')
          }, {
            value: 'recentThree',
            label: t('dateFilter.recentThree')
          }]
        });
      });
    };

    _this.dateChange = function (nextValue) {
      var _this$props = _this.props,
          confirm = _this$props.confirm,
          setSelectedKeys = _this$props.setSelectedKeys;

      if (nextValue && nextValue.length === 2) {
        if (nextValue[0]) {
          nextValue[0] = (0, _moment["default"])(nextValue[0]).startOf('day');
        }

        if (nextValue[1]) {
          nextValue[1] = (0, _moment["default"])(nextValue[1]).endOf('day');
        }

        _this.setState({
          selectedValue: nextValue
        }, function () {
          setSelectedKeys(nextValue);

          if (nextValue.length > 1) {
            confirm();
          }
        });
      }
    };

    _this.onChoose = function (value) {
      var now = new Date();
      var _this$props2 = _this.props,
          confirm = _this$props2.confirm,
          setSelectedKeys = _this$props2.setSelectedKeys;

      _this.setState({
        range: value
      }, function () {
        switch (value) {
          case 'recentThree':
            _this.setState({
              selectedValue: [(0, _moment["default"])(now).subtract(3, 'months'), (0, _moment["default"])()]
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          case 'recentOne':
            _this.setState({
              selectedValue: [(0, _moment["default"])(now).subtract(1, 'months'), (0, _moment["default"])()]
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          case 'all':
            _this.setState({
              selectedValue: []
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          case 'customize':
            _this.setState({
              selectedValue: []
            });

            break;

          default:
            break;
        }
      });
    };

    _this.state = {
      selectedValue: props.selectedKeys || [],
      t: _mkTranslate["default"].noop(),
      rangeOptions: [],
      range: 'all'
    };

    _this.localeProcess();

    return _this;
  }

  _createClass(DateFilter, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var prevSelectedKeys = prevProps.selectedKeys;
      var selectedKeys = this.props.selectedKeys;

      if (!_lodash["default"].isEqual(prevSelectedKeys, selectedKeys)) {
        this.setState({
          selectedValue: selectedKeys
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var isNeedSideBar = this.props.isNeedSideBar;
      var _this$state = this.state,
          selectedValue = _this$state.selectedValue,
          range = _this$state.range,
          rangeOptions = _this$state.rangeOptions;
      return _react["default"].createElement("div", {
        className: "".concat(prefix, "-date-filter")
      }, _react["default"].createElement(_RangeCalendar["default"], {
        renderFooter: function renderFooter() {
          if (isNeedSideBar) {
            return _react["default"].createElement("div", {
              className: "tabs"
            }, rangeOptions.map(function (item, index) {
              return _react["default"].createElement("div", {
                className: 'tab' + (range === item.value ? ' active' : ''),
                onClick: _this2.onChoose.bind(_this2, item.value),
                key: index
              }, item.label);
            }));
          } else {
            return null;
          }
        },
        locale: _zh_CN["default"],
        selectedValue: selectedValue ? selectedValue : [],
        dateInputPlaceholder: ['开始', '结束'],
        showToday: false,
        onChange: function onChange(data) {
          _this2.dateChange(data);
        },
        showOk: false
      }));
    }
  }]);

  return DateFilter;
}(_react.Component);

DateFilter.defaultProps = {
  isNeedSideBar: true
};
var _default = DateFilter;
exports["default"] = _default;