"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/switch/style/css");

var _switch = _interopRequireDefault(require("maycur-antd/lib/switch"));

require("maycur-antd/lib/alert/style/css");

var _alert = _interopRequireDefault(require("maycur-antd/lib/alert"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

require("maycur-antd/lib/form/style/css");

var _form = _interopRequireDefault(require("maycur-antd/lib/form"));

var _react = _interopRequireWildcard(require("react"));

var _CityInput = _interopRequireDefault(require("./CityInput"));

var _BankInput = _interopRequireDefault(require("./BankInput"));

var _BankBranchInput = _interopRequireDefault(require("./BankBranchInput"));

var _CertificateInput = _interopRequireDefault(require("./CertificateInput"));

var _CurrencySelector = _interopRequireDefault(require("../CurrencySelector"));

var _CurrencyFlag = _interopRequireDefault(require("../CurrencyFlag"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _lodash = _interopRequireDefault(require("lodash"));

var _i18next = require("i18next");

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;
var FormItem = _form["default"].Item;
var RadioGroup = _radio["default"].Group;
var radioOptions = [{
  label: (0, _i18next.t)('PaymentAccountModal:editPaymentForm.bank'),
  value: 'BANK'
}, {
  label: (0, _i18next.t)('PaymentAccountModal:editPaymentForm.alipay'),
  value: 'ALIPAY'
}, {
  label: (0, _i18next.t)('PaymentAccountModal:editPaymentForm.cash'),
  value: 'CASH'
}];

var EditPaymentForm =
/*#__PURE__*/
function (_Component) {
  _inherits(EditPaymentForm, _Component);

  function EditPaymentForm(props) {
    var _this;

    _classCallCheck(this, EditPaymentForm);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(EditPaymentForm).call(this, props));

    _this.localeProcess = function () {
      _mkTranslate["default"].getNameSpace('PaymentAccountModal').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.showBranchNoChange = function (value) {
      _this.setState({
        showBranchNo: value
      });
    };

    _this.renderBankLabel = function () {
      var t = _this.state.t;

      var content = _react["default"].createElement("div", {
        style: {
          fontSize: 12,
          color: '#999'
        }
      }, _react["default"].createElement("p", null, t('editPaymentForm.p1')), _react["default"].createElement("p", null, t('editPaymentForm.p2')));

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("span", {
        style: {
          marginRight: 5
        }
      }, t('editPaymentForm.bankLabel')), _react["default"].createElement(_popover["default"], {
        placement: "top",
        content: content
      }, _react["default"].createElement("span", {
        className: "fm fm-question",
        onClick: function onClick(e) {
          e.preventDefault();
          e.stopPropagation();
        }
      })));
    };

    _this.state = {
      showBranchNo: false,
      t: _mkTranslate["default"].noop(),
      defaultValues: '',
      isAutowatch: true
    };
    _this.validate = _this.validate.bind(_assertThisInitialized(_this));
    _this.handleSubmit = _this.handleSubmit.bind(_assertThisInitialized(_this));
    _this.onChangeBank = _this.onChangeBank.bind(_assertThisInitialized(_this));
    _this.onChangeBankBranch = _this.onChangeBankBranch.bind(_assertThisInitialized(_this));
    _this.onBulrchange = _this.onBulrchange.bind(_assertThisInitialized(_this));

    _this.localeProcess();

    return _this;
  }

  _createClass(EditPaymentForm, [{
    key: "handleSubmit",
    value: function handleSubmit() {
      var _this$props = this.props,
          form = _this$props.form,
          onErrors = _this$props.onErrors,
          onSubmit = _this$props.onSubmit;
      form.validateFields(null, {
        force: true
      }, function (errs, values) {
        if (errs) {
          if (typeof onErrors === 'function') {
            onErrors(errs);
          }
        } else {
          if (typeof onSubmit === 'function') {
            onSubmit(values);
          }
        }
      });
    }
  }, {
    key: "validate",
    value: function validate() {
      var form = this.props.form;
      var t = this.state.t;
      return new Promise(function (resolve, reject) {
        form.validateFields(function (errs, values) {
          if (errs) {
            reject(t('editPaymentForm.errMsg'));
          } else {
            resolve(values);
          }
        });
      });
    }
  }, {
    key: "onChangeBank",
    value: function onChangeBank(value, option) {
      this.setState({
        defaultValues: '',
        isAutowatch: false
      });
      var data = option.props.data;
      var onChangeBank = this.props.onChangeBank;

      if (typeof onChangeBank === 'function') {
        onChangeBank(data);
      }
    }
  }, {
    key: "onBulrchange",
    value: function onBulrchange(e) {
      var isAutowatch = this.state.isAutowatch;
      var data = this.props.data;

      if (isAutowatch) {
        this.setState({
          defaultValues: "icbc"
        });
        data.bankCode = "icbc";
        data.bankName = "工商银行";
      }
    }
  }, {
    key: "onChangeBankBranch",
    value: function onChangeBankBranch(value, option) {
      var _option$props = option.props,
          data = _option$props.data,
          showBranchNo = _option$props.showBranchNo;
      var onChangeBankBranch = this.props.onChangeBankBranch;
      this.setState({
        showBranchNo: showBranchNo
      });

      if (typeof onChangeBankBranch === 'function') {
        onChangeBankBranch(data);
      }
    }
  }, {
    key: "filterRadioOptions",
    value: function filterRadioOptions() {
      var paymentTypes = this.props.paymentTypes;
      if (!paymentTypes.length) return radioOptions;
      return radioOptions.filter(function (item) {
        return paymentTypes.includes(item.value);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          data = _this$props2.data,
          getFieldDecorator = _this$props2.form.getFieldDecorator,
          isCompany = _this$props2.isCompany,
          showDescription = _this$props2.showDescription,
          showCurrency = _this$props2.showCurrency,
          currencyLabel = _this$props2.currencyLabel,
          showActive = _this$props2.showActive,
          cities = _this$props2.cities,
          banks = _this$props2.banks,
          currencys = _this$props2.currencys,
          fetchCities = _this$props2.fetchCities,
          fetchBanks = _this$props2.fetchBanks,
          autoRequired = _this$props2.autoRequired,
          fetchBankBranches = _this$props2.fetchBankBranches,
          fetchCertificationTypes = _this$props2.fetchCertificationTypes,
          extra = _this$props2.extra,
          withCurrency = _this$props2.withCurrency;
      var currency = data.acceptCcyDetail;
      var _this$state = this.state,
          showBranchNo = _this$state.showBranchNo,
          t = _this$state.t,
          defaultValues = _this$state.defaultValues;
      var radios = this.filterRadioOptions();
      return _react["default"].createElement(_form["default"], {
        onSubmit: this.handleSubmit,
        className: "".concat(prefix, "-edit-payment-form")
      }, extra, _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.paymentType')
      }, getFieldDecorator('paymentType', {
        rules: [{
          required: true,
          message: t('editPaymentForm.paymentTypeMsg')
        }]
      })(_react["default"].createElement(RadioGroup, {
        options: radios
      }))), data.paymentType === 'BANK' ? _react["default"].createElement("div", {
        className: "bank-section"
      }, _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.bankAcctName')
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNameMsg')
        }, {
          max: 50,
          message: t('editPaymentForm.bankAcctNameMax')
        }]
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.bankAcctNamePlaceholder')
      }))), _react["default"].createElement(FormItem, {
        label: this.renderBankLabel()
      }, getFieldDecorator('bankCode', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankCodeMsg')
        }]
      })(_react["default"].createElement(_BankInput["default"], {
        placeholder: t('editPaymentForm.bankCodePlaceholder'),
        onChange: this.onChangeBank,
        banks: banks,
        fetchBanks: fetchBanks,
        defaultValues: defaultValues
      }))), _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.bankAcctNumber')
      }, getFieldDecorator('bankAcctNumber', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNumberMsg')
        }]
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.bankAcctNumberPlaceholder')
      }))), _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.bankLocation')
      }, getFieldDecorator('bankLocation', {
        rules: [{
          required: autoRequired,
          message: t('editPaymentForm.bankLocationMsg')
        }]
      })(_react["default"].createElement(_CityInput["default"], {
        showAll: true,
        placeholder: t('editPaymentForm.bankLocationPlaceholder'),
        cities: cities,
        fetchCities: fetchCities
      }))), _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.bankBranchBizCode')
      }, getFieldDecorator('bankBranchBizCode', {
        rules: [{
          required: autoRequired,
          message: t('editPaymentForm.bankBranchBizCodeMsg')
        }],
        validateTrigger: 'falsy'
      })(_react["default"].createElement(_BankBranchInput["default"], {
        bankBranchName: data.bankBranchName,
        cityCode: data.bankLocation,
        bankCode: data.bankCode,
        fetchBankBranches: fetchBankBranches,
        onChange: this.onChangeBankBranch,
        showBranchNoChange: this.showBranchNoChange,
        showBranchNo: showBranchNo,
        placeholder: t('editPaymentForm.bankBranchBizCodePlaceholder')
      }))), showBranchNo && _react["default"].createElement(FormItem, {
        extra: _react["default"].createElement(_alert["default"], {
          message: _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("p", {
            style: {
              fontWeight: 700
            }
          }, t('editPaymentForm.bankQuery')), _react["default"].createElement("p", null, t('editPaymentForm.bankMsg'), _react["default"].createElement("a", {
            rel: "noopener noreferrer",
            target: "_blank",
            href: "https://www.hebbank.com/corporbank/otherBankQueryWeb.do"
          }, t('editPaymentForm.bank1')), "\u3001", _react["default"].createElement("a", {
            rel: "noopener noreferrer",
            target: "_blank",
            href: "https://corbank.czbank.com/CORPORBANK/query_unionBank_index.jsp"
          }, t('editPaymentForm.bank2')), "\u3001", _react["default"].createElement("a", {
            rel: "noopener noreferrer",
            target: "_blank",
            href: "https://ibsbjstar.ccb.com.cn/CCBIS/B2CMainPlat?SERVLET_NAME=B2CMainPlat&CCB_IBSVersion=V6&PT_STYLE=1&TXCODE=418105"
          }, t('editPaymentForm.bank3')), "\u3001", _react["default"].createElement("a", {
            rel: "noopener noreferrer",
            target: "_blank",
            href: "http://www.zybank.com.cn/eportal/ui?pageId=364123"
          }, t('editPaymentForm.bank4')))),
          type: "info",
          showIcon: true
        }),
        label: t('editPaymentForm.bankBranchNo')
      }, getFieldDecorator('bankBranchNo', {
        rules: []
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.bankBranchNoPlaceholder')
      })))) : null, data.paymentType === 'BANK' && isCompany && data.bankCode === 'cmbc' ? _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.agencyBizCode')
      }, getFieldDecorator('agencyBizCode', {
        rules: []
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.agencyBizCodePlaceholder')
      }))) : !isCompany && data.bankCode === 'boc' ? _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.certType')
      }, getFieldDecorator('certificationTypeCode', {
        rules: [{
          required: true,
          message: t('editPaymentForm.certTypeMsg')
        }, {
          max: 40,
          message: t('editPaymentForm.certTypeMax')
        }]
      })(_react["default"].createElement(_CertificateInput["default"], {
        fetchCertificationTypes: fetchCertificationTypes,
        placeholder: t('editPaymentForm.certTypePlaceholder')
      }))), _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.identification')
      }, getFieldDecorator('identification', {
        rules: [{
          required: true,
          message: t('editPaymentForm.identificationMsg')
        }]
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.identificationPlaceholder')
      })))) : null, data.paymentType === 'CASH' ? _react["default"].createElement("div", {
        className: "cash-section"
      }, _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.bankAcctName')
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNameMsg')
        }]
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.cashAcctNamePlaceholder')
      })))) : null, data.paymentType === 'ALIPAY' ? _react["default"].createElement("div", {
        className: "alipay-section"
      }, _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.bankAcctNameAli')
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNameAliMsg')
        }]
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.bankAcctNameAliPlaceholder')
      }))), _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.bankAcctNumberAli')
      }, getFieldDecorator('bankAcctNumber', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNumberAliMsg')
        }]
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.bankAcctNumberAliPlaceholder')
      })))) : null, showDescription && _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.description')
      }, getFieldDecorator('description', {
        rules: []
      })(_react["default"].createElement(_input["default"], {
        placeholder: t('editPaymentForm.descriptionPlaceholder')
      }))), showCurrency && _react["default"].createElement(FormItem, {
        label: currencyLabel
      }, getFieldDecorator('acceptCcyDetail', {
        rules: [{
          required: true,
          message: "".concat(currencyLabel, "\u4E0D\u80FD\u4E3A\u7A7A")
        }]
      })(_react["default"].createElement(_CurrencySelector["default"], {
        data: currencys,
        disabled: true
      }, _react["default"].createElement("div", {
        className: "form-currency-wrapper"
      }, _lodash["default"].isEmpty(currency) ? _react["default"].createElement("div", null, "\u8BF7\u9009\u62E9", currencyLabel) : _react["default"].createElement("div", {
        className: "form-currency"
      }, _react["default"].createElement(_CurrencyFlag["default"], {
        flagInfo: {
          code: currency.code
        }
      }), _react["default"].createElement("span", {
        style: {
          marginLeft: 4
        }
      }, currency.code, " - ", currency.name)))))), showActive && _react["default"].createElement(FormItem, {
        label: t('editPaymentForm.active')
      }, getFieldDecorator('active', {
        valuePropName: 'checked'
      })(_react["default"].createElement(_switch["default"], null))), data.paymentType === 'BANK' && withCurrency ? _react["default"].createElement(FormItem, {
        label: "\u8D26\u6237\u540D"
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: '账户名不能为空'
        }, {
          max: 50,
          message: '最多输入50个字符'
        }]
      })(_react["default"].createElement(_input["default"], {
        placeholder: "\u94F6\u884C\u8D26\u6237\u540D\u79F0"
      }))) : null);
    }
  }]);

  return EditPaymentForm;
}(_react.Component);

var mapPropsToFields = function mapPropsToFields(props) {
  var data = props.data || {};
  var fields = props.fields || {};
  var extraName = props.extraName || {};
  return {
    paymentType: _form["default"].createFormField(_objectSpread({}, fields['paymentType'], {
      value: data.paymentType
    })),
    paymentCode: _form["default"].createFormField(_objectSpread({}, fields['paymentCode'], {
      value: data.paymentCode || undefined
    })),
    bankCode: _form["default"].createFormField(_objectSpread({}, fields['bankCode'], {
      value: data.bankCode || undefined
    })),
    bankAcctName: _form["default"].createFormField(_objectSpread({}, fields['bankAcctName'], {
      value: data.bankAcctName || extraName.name
    })),
    bankAcctNumber: _form["default"].createFormField(_objectSpread({}, fields['bankAcctNumber'], {
      value: data.bankAcctNumber || undefined
    })),
    bankLocation: _form["default"].createFormField(_objectSpread({}, fields['bankLocation'], {
      value: data.bankLocation || undefined
    })),
    bankBranchBizCode: _form["default"].createFormField(_objectSpread({}, fields['bankBranchBizCode'], {
      value: data.bankBranchBizCode || undefined
    })),
    bankBranchNo: _form["default"].createFormField(_objectSpread({}, fields['bankBranchNo'], {
      value: data.bankBranchNo || undefined
    })),
    description: _form["default"].createFormField(_objectSpread({}, fields['description'], {
      value: data.description || undefined
    })),
    active: _form["default"].createFormField(_objectSpread({}, fields['active'], {
      value: data.active
    })),
    agencyBizCode: _form["default"].createFormField(_objectSpread({}, fields['agencyBizCode'], {
      value: data.agencyBizCode
    })),
    certificationTypeCode: _form["default"].createFormField(_objectSpread({}, fields['certificationTypeCode'], {
      value: data.certificationTypeCode || undefined
    })),
    identification: _form["default"].createFormField(_objectSpread({}, fields['identification'], {
      value: data.identification || undefined
    })),
    acceptCcyDetail: _form["default"].createFormField(_objectSpread({}, fields['acceptCcyDetail'], {
      value: data.acceptCcyDetail || undefined
    }))
  };
};

var onFieldsChange = function onFieldsChange(props, changedFields) {
  var onChange = props.onChange;

  if (typeof onChange === 'function') {
    onChange(changedFields);
  }
};

var _default = _form["default"].create({
  mapPropsToFields: mapPropsToFields,
  onFieldsChange: onFieldsChange
})(EditPaymentForm);

exports["default"] = _default;