"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = intersect;

var _isobject = _interopRequireDefault(require("./isobject"));

var _error = _interopRequireDefault(require("./error"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Computes true or false if two rectangles intersect.
// A rect is defined as having left, right, top and bottom.
function intersect(a, b) {
  if (!(0, _isobject["default"])(a)) return _error["default"].na;
  if (!(0, _isobject["default"])(b)) return _error["default"].na;
  return Math.max(a.left, b.left) < Math.min(a.right, b.right) && Math.max(a.top, b.top) < Math.min(a.bottom, b.bottom);
}